'use strict';

const path = require("path");
const createError = require("create-error");

const qmp = require("./qmp");
const api = require("./api");

const NotImplementedError = createError("NotImplementedError");

module.exports = function createKvmWrapper(instanceId, options) {
	return Promise.try(() => {
		return qmp(path.join(__dirname, `../../../qmp-sockets/${instanceId}`));
	}).then((socket) => {
		return api(socket, Object.assign({instanceId: instanceId}, options));
	});
}
