'use strict';

const errorChain = require("error-chain");

let HttpError = errorChain("HttpError", {
	exposeToUser: true
});

module.exports = {
	UnauthorizedError: errorChain("UnauthorizedError", {
		statusCode: 401
	}, HttpError),
	ForbiddenError: errorChain("ForbiddenError", {
		statusCode: 403
	}, HttpError),

	UnexpectedOutput: errorChain("UnexpectedOutput"),
	ExpectedOutputMissing: errorChain("ExpectedOutputMissing"),
	NonZeroExitCode: errorChain("NonZeroExitCode"),
	CommandExecutionFailed: errorChain("CommandExecutionFailed"),
	InvalidPath: errorChain("InvalidPath"),
	InvalidName: errorChain("InvalidName"),
	PartitionExists: errorChain("PartitionExists"),
	VolumeGroupExists: errorChain("VolumeGroupExists"),
	InvalidVolumeGroup: errorChain("InvalidVolumeGroup"),
	PhysicalVolumeInUse: errorChain("PhysicalVolumeInUse"),
};
